function effects.init()
	local blood = load_particle("blood.obj")
	local bloodScreenTimer = 0
	ch_bloodscreen = 1

	console_register_command("PM_CH_BLOODSCREEN",function(i)
		if i == nil then
			return "PM_CH_BLOODSCREEN IS: "..ch_bloodscreen.." DEFAULT: 1"
		elseif i ~= nil then
			local i = i *1
			if tonumber(i) and i <= 1 and i >= 0 then
				ch_bloodscreen = i
			else
				return "PM_CH_BLOODSCREEN IS: "..ch_bloodscreen.." DEFAULT: 1"
			end
		end
	end)

	function bindings.viewportRender(viewport, worm)
		local bitmap = viewport:bitmap()
		local p = worm:player()

		if ch_bloodscreen == 1 then
			if worm:health() <= 0 and p:team() ~= 0  and p:deaths() > 0 then
				if bloodScreenTimer < 100 then
					bloodScreenTimer = bloodScreenTimer + 0.5
				end
				gfx_set_alphach(bloodScreenTimer)
					bitmap:draw_box(0, 0, 320, 240, color(215,0,0))
				gfx_reset_blending()
			else
				bloodScreenTimer = 0
			end
		end
	end

	function bindings.playerInit(p)
		local d = p:data()
		
		d.respawn = false
	end

	function bindings.playerUpdate(player)
		local w = player:worm()
		local d = player:data()

		if (w:health() - randomint(1,350)) < -307 and w:health() > 0 then
			w:shoot(blood,1,0.1,0.1,1,0,360,0,0)
		end
	
		if d.respawn == false then
			if w then
				if w:health() > 0 then
					d.respawn = true
					effects.spawn(player)
				end
			end
		else
			if w then
				if w:health() <= 0 then
					d.respawn = false
				end
			else
				d.respawn = false
			end
		end
	end

	local spawnPlayer = load_particle("respawn.obj")

	function effects.spawn(player)
		player:worm():shoot(spawnPlayer,1,0,0,0,0,0,0,0)
	end

	function effects.follow(object)
		object:set_pos(object:player():worm():pos())
		object:set_spd(object:player():worm():spd())
	end

end
