function hud.init()
	if not DEDSERV then
		cg_enemybox = 0
		cg_teambox = 0
		ch_playerhealth = 1
		ch_playernames = 1
		ch_crosshairtype = 1
		ch_crosshairdist = 25
		ch_radar = 1
		ch_radartype = 0
		ch_statusbar = 1
		ch_reloadtimer = 1
		crossh = {r = "0", g = "255", b = "0"}
		enemy = {r = "0", g = "255", b = "0"}
		friend = {r = "0", g = "0", b = "255"}

		console_register_command("PM_CH_STATUSBAR",function(i)
			if i == nil then
				return "PM_CH_STATUSBAR IS: "..ch_statusbar.." DEFAULT: 1"
			elseif i ~= nil then
				local i = i *1
				if tonumber(i) and i <= 4 and i >= 0 then
					ch_statusbar = i
				else
					return "PM_CH_STATUSBAR IS: "..ch_statusbar.." DEFAULT: 1"
				end
			end
		end)

		console_register_command("PM_CH_RELOADTIMER",function(i)
			if i == nil then
				return "PM_CH_RELOADTIMER IS: "..ch_reloadtimer.." DEFAULT: 1"
			elseif i ~= nil then
				local i = i *1
				if tonumber(i) and i <= 1 and i >= 0 then
					ch_reloadtimer = i
				else
					return "PM_CH_RELOADTIMER IS: "..ch_reloadtimer.." DEFAULT: 1"
				end
			end
		end)

		console_register_command("PM_CH_CROSSHAIRTYPE",function(i)
			if i == nil then
				return "PM_CH_CROSSHAIRTYPE IS: "..ch_crosshairtype.." DEFAULT: 1"
			elseif i ~= nil then
				local i = i *1
				if tonumber(i) and i <= 7 and i >= 0 then
					ch_crosshairtype = i
				else
					return "PM_CH_CROSSHAIRTYPE IS: "..ch_crosshairtype.." DEFAULT: 1"
				end
			end
		end)

		console_register_command("PM_CH_CROSSHAIRDIST",function(i)
			if i == nil then
				return "PM_CH_CROSSHAIRDIST IS: "..ch_crosshairdist.." DEFAULT: 25"
			elseif i ~= nil then
				local i = i *1
				if tonumber(i) and i <= 30 and i >= 0 then
					ch_crosshairdist = i
				else
					return "PM_CH_CROSSHAIRDIST IS: "..ch_crosshairdist.." DEFAULT: 25"
				end
			end
		end)

		console_register_command("PM_CH_CROSSHAIRCOLOR",function(i,j,k)
			if i == nil then
				return "PM_CH_CROSSHAIRCOLOR IS: "..crossh.r.." "..crossh.g.." "..crossh.b.." DEFAULT: 0 255 0"
			elseif i ~= nil then
				local i = i *1
				local j = j *1
				local k = k *1
				if tonumber(i) and tonumber(j) and tonumber(k) then
					if i >= 0 and i <= 255 then
						if j >= 0 and j <= 255 then
							if k >= 0 and k <= 255 then
								crossh.r = i
								crossh.g = j
								crossh.b = k
							end
						end
					end
				else
					return "PM_CH_CROSSHAIRCOLOR IS: "..crossh.r.." "..crossh.g.." "..crossh.b.." DEFAULT: 0 255 0"
				end
			end
		end)
	
		console_register_command("PM_CG_ENEMYBOX",function(i)
			if i == nil then
				return "PM_CG_ENEMYBOX IS: "..cg_enemybox.." DEFAULT: 0"
			elseif i ~= nil then
				local i = i *1
				if tonumber(i) and i <= 1 and i >= 0 then
					cg_enemybox = i
				else
					return "PM_CG_ENEMYBOX IS: "..cg_enemybox.." DEFAULT: 0"
				end
			end
		end)

		console_register_command("PM_CG_ENEMYCOLOR",function(i,j,k)
			if i == nil then
				return "PM_CG_ENEMYCOLOR IS: "..enemy.r.." "..enemy.g.." "..enemy.b.." DEFAULT: 0 255 0"
			elseif i ~= nil then
				local i = i *1
				local j = j *1
				local k = k *1
				if tonumber(i) and tonumber(j) and tonumber(k) then
					if i >= 0 and i <= 255 then
						if j >= 0 and j <= 255 then
							if k >= 0 and k <= 255 then
								enemy.r = i
								enemy.g = j
								enemy.b = k
							end
						end
					end
				else
					return "PM_CG_ENEMYCOLOR IS: "..enemy.r.." "..enemy.g.." "..enemy.b.." DEFAULT: 0 255 0"
				end
			end
		end)

		console_register_command("PM_CG_TEAMBOX",function(i)
			if i == nil then
				return "PM_CG_TEAMBOX IS: "..cg_teambox.." DEFAULT: 0"
			elseif i ~= nil then
				local i = i *1
				if tonumber(i) and i <= 1 and i >= 0 then
					cg_teambox = i
				else
					return "PM_CG_TEAMBOX IS: "..cg_teambox.." DEFAULT: 0"
				end
			end
		end)

		console_register_command("PM_CG_TEAMCOLOR",function(i,j,k)
			if i == nil then
				return "PM_CG_TEAMCOLOR IS: "..friend.r.." "..friend.g.." "..friend.b.." DEFAULT: 0 0 255"
			elseif i ~= nil then
				local i = i *1
				local j = j *1
				local k = k *1
				if tonumber(i) and tonumber(j) and tonumber(k) then
					if i >= 0 and i <= 255 then
						if j >= 0 and j <= 255 then
							if k >= 0 and k <= 255 then
								friend.r = i
								friend.g = j
								friend.b = k
							end
						end
					end
				else
					return "PM_CG_TEAMCOLOR IS: "..friend.r.." "..friend.g.." "..friend.b.." DEFAULT: 0 0 255"
				end
			end
		end)

		console_register_command("PM_CH_PLAYERHEALTH",function(i)
			if i == nil then
				return "PM_CH_PLAYERHEALTH IS: "..ch_playerhealth.." DEFAULT: 1"
			elseif i ~= nil then
				local i = i *1
				if tonumber(i) and i <= 1 and i >= 0 then
					ch_playerhealth = i
				else
					return "PM_CH_PLAYERHEALTH IS: "..ch_playerhealth.." DEFAULT: 0"
				end
			end
		end)
		
		console_register_command("PM_CH_PLAYERNAMES",function(i)
			if i == nil then
				return "PM_CH_PLAYERNAMES IS: "..ch_playernames.." DEFAULT: 1"
			elseif i ~= nil then
				local i = i *1
				if tonumber(i) and i <= 1 and i >= 0 then
					ch_playernames = i
				else
					return "PM_CH_PLAYERNAMES IS: "..ch_playernames.." DEFAULT: 0"
				end
			end
		end)

		console_register_command("PM_CH_RADAR",function(i)
			if i == nil then
				return "PM_CH_RADAR IS: "..ch_radar.." DEFAULT: 1"
			elseif i ~= nil then
				local i = i *1
				if tonumber(i) and i <= 1 and i >= 0 then
					ch_radar = i
				else
					return "PM_CH_RADAR IS: "..ch_radar.." DEFAULT: 1"
				end
			end
		end)
		
		console_register_command("PM_CH_RADARTYPE",function(i)
			if i == nil then
				return "PM_CH_RADARTYPE IS: "..ch_radartype.." DEFAULT: 1"
			elseif i ~= nil then
				local i = i *1
				if tonumber(i) and i <= 2 and i >= 0 then
					ch_radartype = i
				else
					return "PM_CH_RADARTYPE IS: "..ch_radartype.." DEFAULT: 1"
				end
			end
		end)

		function drawWormBox(bitmap, x, y, worm, friend_)
			local colour = {}

			if friend_ then 
				colour = friend
			else
				colour = enemy
			end

			gfx_set_alpha(30)
				bitmap:draw_box(x - 6, y - 7, x + 6, y + 7, color(colour.r,colour.g,colour.b))
			gfx_set_alpha(180)
				bitmap:line(x - 7, y - 7, x + 6, y - 7, color(colour.r,colour.g,colour.b))
				bitmap:line(x + 7, y + 7-1, x - 6, y + 7-1, color(colour.r,colour.g,colour.b))
				bitmap:line(x - 6, y - 8, x - 6, y + 4, color(colour.r,colour.g,colour.b))
				bitmap:line(x + 6, y + 8-1, x + 6, y - 5, color(colour.r,colour.g,colour.b))	
			gfx_reset_blending()		
		end
		
		function drawWormDot(bitmap, x, y, friend_)
			local color = {}

			if friend_ then 
				color = friend
			else
				color = enemy
			end

			gfx_set_alphach(255)
				bitmap:putpixel(x, y, color.r, color.g, color.b)
			gfx_reset_blending()
			if ch_radartype == 1 or ch_radartype == 2 then
				gfx_set_alphach(130)
					bitmap:putpixel(x-1, y, color.r, color.g, color.b)
					bitmap:putpixel(x+1, y, color.r, color.g, color.b)
					bitmap:putpixel(x, y+1, color.r, color.g, color.b)
					bitmap:putpixel(x, y-1, color.r, color.g, color.b)
				gfx_reset_blending()
			end
			if ch_radartype == 2 then
				gfx_set_alphach(30)
					bitmap:putpixel(x-1, y-1, color.r, color.g, color.b)
					bitmap:putpixel(x-1, y+1, color.r, color.g, color.b)
					bitmap:putpixel(x+1, y+1, color.r, color.g, color.b)
					bitmap:putpixel(x+1, y-1, color.r, color.g, color.b)
				gfx_reset_blending()
			end
		end

		local hudFont = fonts.liero
		local testCrosshair = sprites_load("crosshair")
		local killsMeter = sprites_load("kills")
		local hudBar = sprites_load("hud_jrc_bar")
		local hudBarDown = sprites_load("hud_up")
		local reloadTimer = 0

		function bindings.viewportRender(viewport, worm)
			local bitmap = viewport:bitmap()
			local filled = (worm:health() / 100)
			local limit = 200-filled*2
			
			if worm:health() > 0 then					
			if ch_statusbar == 1 then
				hudBarDown:render(bitmap,0,bitmap:w()/2-55,0)
				hudBarDown:render(bitmap,0,bitmap:w()/2+55,0)
			
				if filled < 0.3 then
					fonts.minifont:render(bitmap,(floor(filled*100)).."/100",bitmap:w()/2+54,6,color(255,127,0),Font.Formatting +Font.CenterH + Font.CenterV )				else
					fonts.minifont:render(bitmap,(floor(filled*100)).."/100",bitmap:w()/2+54,6,color(0,255,0),Font.Formatting +Font.CenterH + Font.CenterV )
				end

				if filled > 0 then
					gfx_set_alpha(100)
						bitmap:draw_box(bitmap:w()/2+55, 3, (bitmap:w()/2+55)+(38-2)*filled, 1, hudtools.greenRedInterpol(1-filled))
						bitmap:draw_box((bitmap:w()/2+55)+(38-2)*(-filled), 3,bitmap:w()/2+55, 1, hudtools.greenRedInterpol(1-filled))
					gfx_reset_blending()

					bitmap:draw_box(bitmap:w()/2+55, 2, (bitmap:w()/2+55)+(37-2)*filled,2, hudtools.greenRedInterpol(1-filled))
					bitmap:draw_box((bitmap:w()/2+55)+(37-2)*(-filled), 2,bitmap:w()/2+55, 2, hudtools.greenRedInterpol(1-filled))
				end
				local afilled = (worm:current_weapon():ammo())
				local w = worm:current_weapon()
				if w:is_reloading() then
					fonts.minifont:render(bitmap,100-floor(w:reload_time()/w:type():reload_time()*100).." %",bitmap:w()/2-56,6,color(255,0,0),Font.Formatting +Font.CenterH + Font.CenterV )
				else
					if w:type():name() == "Lightning Gun" then
						if w:ammo() < w:type():ammo() / 4 or (w:ammo() == 1 and w:type():ammo() > 1) then
							fonts.minifont:render(bitmap,floor(w:ammo()/10).." / "..floor(w:type():ammo()/10),bitmap:w()/2-56,6,color(255,180,0),Font.Formatting +Font.CenterH + Font.CenterV )
						else
							fonts.minifont:render(bitmap,floor(w:ammo()/10).." / "..floor(w:type():ammo()/10),bitmap:w()/2-56,6,color(0,255,0),Font.Formatting +Font.CenterH + Font.CenterV )
						end
					else
						if w:ammo() < w:type():ammo() / 4 or (w:ammo() == 1 and w:type():ammo() > 1) then
							fonts.minifont:render(bitmap,w:ammo().." / "..w:type():ammo(),bitmap:w()/2-56,6,color(255,180,0),Font.Formatting +Font.CenterH + Font.CenterV )
						else
							fonts.minifont:render(bitmap,w:ammo().." / "..w:type():ammo(),bitmap:w()/2-56,6,color(0,255,0),Font.Formatting +Font.CenterH + Font.CenterV )
						end
					end
				end
				local afilled = 0
				if w:is_reloading() then
					afilled = 1 - w:reload_time() / w:type():reload_time()
				else
					afilled = w:ammo() / w:type():ammo()
				end
				gfx_set_alpha(100)
					bitmap:draw_box(bitmap:w()/2-55, 237, (bitmap:w()/2-55)+(38-2)*afilled, 1, hudtools.greenRedInterpol(1-afilled))
					bitmap:draw_box((bitmap:w()/2-55)+(38-2)*(-afilled), 3,bitmap:w()/2-55, 1, hudtools.greenRedInterpol(1-afilled))
				gfx_reset_blending()

				bitmap:draw_box(bitmap:w()/2-55, 2, (bitmap:w()/2-55)+(37-2)*afilled,2, hudtools.greenRedInterpol(1-afilled))
				bitmap:draw_box((bitmap:w()/2-55)+(37-2)*(-afilled), 2,bitmap:w()/2-55, 2, hudtools.greenRedInterpol(1-afilled))
			elseif ch_statusbar == 2 then
				hudBar:render(bitmap,0,bitmap:w()/2,0)
				if filled > 0 then
					gfx_set_alpha(100)
						bitmap:draw_box(bitmap:w()/2, 1, (bitmap:w()/2)+(38-2)*filled, 3, hudtools.greenRedInterpol(1-filled))
						bitmap:draw_box((bitmap:w()/2)+(38-2)*(-filled), 1,bitmap:w()/2, 3, hudtools.greenRedInterpol(1-filled))
					gfx_reset_blending()

					bitmap:draw_box(bitmap:w()/2, 2, (bitmap:w()/2)+(37-2)*filled, 2, hudtools.greenRedInterpol(1-filled))
					bitmap:draw_box((bitmap:w()/2)+(37-2)*(-filled), 2,bitmap:w()/2, 2, hudtools.greenRedInterpol(1-filled))
				end
			
				local w = worm:current_weapon()
				if w:is_reloading() then
					fonts.minifont:render(bitmap,100-floor(w:reload_time()/w:type():reload_time()*100).." %",bitmap:w()/2,6,color(255,0,0),Font.Formatting +Font.CenterH + Font.CenterV )
				else
					if w:type():name() == "Lightning Gun" then
						if w:ammo() < w:type():ammo() / 4 or (w:ammo() == 1 and w:type():ammo() > 1) then
							fonts.minifont:render(bitmap,floor(w:ammo()/10).." / "..floor(w:type():ammo()/10),bitmap:w()/2-1,6,color(255,180,0),Font.Formatting +Font.CenterH + Font.CenterV )
						else
							fonts.minifont:render(bitmap,floor(w:ammo()/10).." / "..floor(w:type():ammo()/10),bitmap:w()/2-1,6,color(0,255,0),Font.Formatting +Font.CenterH + Font.CenterV )
						end
					else
						if w:ammo() < w:type():ammo() / 4 or (w:ammo() == 1 and w:type():ammo() > 1) then
							fonts.minifont:render(bitmap,w:ammo().." / "..w:type():ammo(),bitmap:w()/2-1,6,color(255,180,0),Font.Formatting +Font.CenterH + Font.CenterV )
						else
							fonts.minifont:render(bitmap,w:ammo().." / "..w:type():ammo(),bitmap:w()/2-1,6,color(0,255,0),Font.Formatting +Font.CenterH + Font.CenterV )
						end
					end
				end
			elseif ch_statusbar == 3 then
				killsMeter:render(bitmap, 0, bitmap:w()-140, 6)
				fonts.minifont:render(bitmap, worm:player():kills(), bitmap:w()-135, 4, color(255, 255, 255), 0)
	
				hudtools.drawHBar( bitmap, filled, bitmap:w()-54, 5, 50, 4 )	
				local w = worm:current_weapon()
	
				if w:is_reloading() then
					filled = 1 - w:reload_time() / w:type():reload_time()
				else
					filled = w:ammo() / w:type():ammo()
				end
	
				hudtools.drawHBar( bitmap, filled, bitmap:w()-109, 5, 50, 4 )
			elseif ch_statusbar == 4 then
				fonts.liero:render(bitmap, "Kills: ", 2, 206, color(84, 215, 84), Font.Shadow)
				fonts.liero:render(bitmap, "Deaths: ", 2, 214, color(252, 84, 84), Font.Shadow)
				fonts.liero:render(bitmap, worm:player():kills(), 21, 206, color(84, 215, 84), Font.Shadow)
				fonts.liero:render(bitmap, worm:player():deaths(), 31, 214, color(252, 84, 84), Font.Shadow)
				
				if filled > 0 then
					hudtools.drawLieroHBar(bitmap, filled,2, 194, 101, 3)
				else
					hudtools.drawLieroHBar(bitmap, 1, 2, 194, 101, 3)
				end

				local w = worm:current_weapon()
		
				if reloadTimer == 100 then
					reloadTimer = 0
				end

				reloadTimer = reloadTimer + 1
					
				if w:is_reloading() then
					aFilled = 1 - w:reload_time() / w:type():reload_time()
					aFilled2 = 0
				else
					aFilled = w:ammo() / w:type():ammo()
					aFilled2 = w:ammo()
				end

				hudtools.drawLieroABar(bitmap, aFilled, 2, 200, 101, 3)

				if w:is_reloading() then
					if reloadTimer <= 100 and reloadTimer >= 50 then
						fonts.liero:render(bitmap, "Reloading...", 6, 199, color(255, 255, 255), Font.Shadow)
					end
				end
			elseif ch_statusbar == 5 then
				if worm:is_changing() then
					fonts.minifont:render( bitmap, worm:current_weapon():type():name(), bitmap:w()-32, 200, color(150, 255, 255), Font.Formatting + Font.Right)
				else 
					fonts.minifont:render( bitmap, worm:current_weapon():type():name(), bitmap:w()-32, 200, color(255, 255, 255), Font.Formatting + Font.Right )
				end
				
				gfx_set_alpha(202)
					if worm:current_weapon():is_reloading() then
						fonts.minifont:render( bitmap, "02RELOADING00 " .. floor((worm:current_weapon():type():reload_time() - worm:current_weapon():reload_time()) / worm:current_weapon():type():reload_time() * 100) .. " %", bitmap:w()-32, 208, color(255, 255, 255), Font.Formatting + Font.Right )
					else
						fonts.minifont:render( bitmap, worm:current_weapon():ammo() .. "/" .. worm:current_weapon():type():ammo(), bitmap:w()-32, 208, color(255, 255, 255), Font.Formatting + Font.Right )
					end				
				gfx_reset_blending()

				hudtools.cogDrawHealth( bitmap, worm:health(), bitmap:w()-21, 200 )
	
				local w = worm:current_weapon()
				if w:is_reloading() then
					filled = 1 - w:reload_time() / w:type():reload_time()
				else
					filled = w:ammo() / w:type():ammo()
				end
				hudtools.cogDrawAmmo( bitmap, filled, bitmap:w()-8, 200 )
			end
			end
		end
	
		function bindings.wormRender(x, y, worm, viewport, ownerPlayer)
			local ownViewport = ( ownerPlayer == worm:player() )
			local bitmap = viewport:bitmap()
			local dx, dy = angle_vector(worm:angle(), 25)
			local dot_offset = 20
			local dot_offset2 = 60
		
			if worm:health() > 0 then	
			if not ownViewport then
				if ch_playerhealth == 1 then
					bitmap:draw_box(x - 5, y + 9, x + 5, y + 11, color(0, 0, 0))
					local filled = (worm:health() / 100)
					bitmap:draw_box(x - 4, y + 10, x - 4 + filled * 8, y + 10, hudtools.greenRedInterpol(1-filled))
				end
			
				local colour = {}

				if friend_ then 
					colour = friend
				else
					colour = enemy
				end

				local ownerWorm = ownerPlayer:worm()
				local x1, y1 = ownerWorm:pos()
				local x2, y2 = worm:pos()
				local relAngle = vector_direction(x1, y1, x2, y2)
				local isFriend = ( ownerPlayer:team() == worm:player():team() ) and ( ownerPlayer:team() ~= -1)
				
				if ch_playernames == 1 then
					if isFriend and gameMode == 3 or gameMode == 4 then
						if cg_teambox == 1 then
							fonts.minifont:render( bitmap, worm:player():name(), x, y - 14, color(255, 255, 255), Font.Formatting + Font.CenterH + Font.CenterV )			
						else
							fonts.minifont:render( bitmap, worm:player():name(), x, y - 10, color(255, 255, 255), Font.Formatting + Font.CenterH + Font.CenterV )			
						end
					else
						--if abs(angle_diff(ownerWorm:angle(), relAngle)) < 135 then
							--if not map_is_blocked(x1, y1, x2, y2) then
								if cg_enemybox == 1 then
									fonts.minifont:render( bitmap, worm:player():name(), x, y - 14, color(255, 255, 255), Font.Formatting + Font.CenterH + Font.CenterV )	
								else
									fonts.minifont:render( bitmap, worm:player():name(), x, y - 10, color(255, 255, 255), Font.Formatting + Font.CenterH + Font.CenterV )	
								end
							--end
						--end
					end
				end
				
				if ownerWorm:health() > 0 then									
					if cg_teambox == 1 then	
						if isFriend then
							if gameMode == 3 or gameMode == 4 then
								drawWormBox(bitmap, x, y, worm, true )
							else
								if abs(angle_diff(ownerWorm:angle(), relAngle)) < 135 then
									if not map_is_blocked(x1, y1, x2, y2) then
										--drawWormBox(bitmap, x, y, worm, false )
									end
								end
							end
						end
					end
	
					if cg_enemybox == 1 then		
						if not isFriend or (gameMode ~= 3 and gameMode ~= 4)  then							
							if ownerWorm then
								if abs(angle_diff(ownerWorm:angle(), relAngle)) < 135 then
									if not map_is_blocked(x1, y1, x2, y2) then
										drawWormBox(bitmap, x, y, worm, false)
									end
								end
							end
						end
					end
				end
			else
				if worm:is_changing() then
					fonts.minifont:render( bitmap, worm:current_weapon():type():name(), x, y - 10, color(255, 255, 255), Font.Formatting + Font.CenterH + Font.CenterV )
				end

				local w = worm:current_weapon()
				if ch_reloadtimer == 1 then
				if w:is_reloading() then			
					hudFont:render(bitmap,floor(w:reload_time()/30),x+1,y-17,color(255,255,255),Font.Formatting +Font.CenterH + Font.CenterV )
					for i=1,36 do
						tx,ty = angle_vector(i*10,5)
						if i/36 < 1 - w:reload_time() / w:type():reload_time() then
							bitmap:putpixelwu(x+tx,y+ty-17,color(0,255-(36-i)*4,0))
						else
							bitmap:putpixelwu(x+tx,y+ty-17,color(0,0,0))
						end
					end
				end
				end

				local dx, dy = angle_vector(worm:angle(), ch_crosshairdist)
				local dxl, dyl = angle_vector(worm:angle(), ch_crosshairdist+4)
		
				if ch_crosshairtype == 1 then
					bitmap:putpixel(x+dx, y+dy, crossh.r, crossh.g, crossh.b)
				elseif ch_crosshairtype == 2 then
					bitmap:putpixel(x+dx, y+dy, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx-1, y+dy, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx+1, y+dy, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx, y+dy+1, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx, y+dy-1, crossh.r, crossh.g, crossh.b)
				elseif ch_crosshairtype == 3 then
					bitmap:putpixel(x+dx-1, y+dy, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx+1, y+dy, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx, y+dy+1, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx, y+dy-1, crossh.r, crossh.g, crossh.b)
				elseif ch_crosshairtype == 4 then
					bitmap:putpixel(x+dx-2, y+dy, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx+2, y+dy, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx, y+dy+2, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx, y+dy-2, crossh.r, crossh.g, crossh.b)
				elseif ch_crosshairtype == 5 then
					bitmap:putpixel(x+dx-1, y+dy, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx+1, y+dy, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx, y+dy+1, crossh.r, crossh.g, crossh.b0)
					bitmap:putpixel(x+dx, y+dy-1, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx-1, y+dy-1, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx-1, y+dy+1, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx+1, y+dy+1, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx+1, y+dy-1, crossh.r, crossh.g, crossh.b)					
				elseif ch_crosshairtype == 6 then			
					bitmap:putpixel(x+dx-1, y+dy-1, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx-1, y+dy+1, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx+1, y+dy+1, crossh.r, crossh.g, crossh.b)
					bitmap:putpixel(x+dx+1, y+dy-1, crossh.r, crossh.g, crossh.b)
				elseif ch_crosshairtype == 7 then			
					bitmap:line(x+dx, y+dy, x+dxl, y+dyl, color(crossh.r, crossh.g, crossh.b))
				end

				ox,oy = worm:pos()

				if ch_radar == 1 then
					for p in game_players() do
						if p ~= worm:player() then
							local worm2 = p:worm()
	
							if worm2:health() > 0 then
								ex,ey = worm2:pos()
								local angle = vector_direction(ex,ey,ox,oy)
								px = math.sin(math.rad(angle)) * dot_offset2
								py = math.cos(math.rad(angle)) * dot_offset2
	
								if gameMode ~= 3 and gameMode ~= 4 then					
									if abs(angle_diff(worm:angle(), angle)) > 135 then
										if not map_is_blocked(ex, ey, ox, oy) then
											if vector_distance(ex,ey,ox,oy) > 70 then													
												drawWormDot(bitmap, x-px, y+py, false)
											end
										end
									end
								else
									if worm:player():team() ~= p:team() then
										if abs(angle_diff(worm:angle(), angle)) > 135 then
											if not map_is_blocked(ex, ey, ox, oy) then
												if vector_distance(ex,ey,ox,oy) > 70 then			
													drawWormDot(bitmap, x-px, y+py, false)
												end
											end
										end
									else
										if vector_distance(ex,ey,ox,oy) > 70 then
											drawWormDot(bitmap, x-px, y+py, true)
										end
									end
								end
							end
						end
					end
				end
			end
			end
		end
	end
end
