function beretta.init()

local beretta_bullet = load_particle("beretta_bullet.obj")
local beretta_muzzle = load_particle("flash_medium_add.obj")
local beretta_smoke = load_particle("small_smoke_alphach.obj")
local beretta_shell = load_particle("shell.obj")
local beretta_sound = sounds["beretta1.ogg"]

 function beretta.shoot(worm)
  worm:data().beretta = 21
  end

 function beretta.gun(worm)
  local ammo = worm:data().beretta
  if ammo then
   ammo = ammo - 1
   if ammo % 16 == 0 then
    local bullet = worm:shoot(beretta_bullet, 1, 1, 0, 0, 0, 4, 0, 4)
    beretta_sound:play(worm,nil,100,0.9,0)
    local muzzle = worm:shoot(beretta_muzzle, 1 , 1, 0, 0, 0, 2, 0, 2 )
    local smoke = worm:shoot(beretta_smoke, 1 , 0.5, 1, 5, 5 )
    local shell = worm:shoot(beretta_shell, 1 , 0.6, 0.2, 0.5, 0, 20, -100)
    local angle = worm:angle()
    bullet:set_spd(angle_vector(angle, 1))
   end
   if ammo == 0 then
    ammo = nil
   end
   worm:data().beretta = ammo
  end
 end
end
