function damage.init()

--MAIN DAMAGE SCRIPT
	function damage.main(object,worm,amount, name)
		if gameMode == 3 or gameMode == 4 then
			if object:player() ~= worm:player() then
				if object:player():team() ~= worm:player():team() then
					worm:damage(amount,object:player())
					stats.add(object, "hits", name)
				end
			else
				worm:damage(amount,object:player())
				stats.add(object, "hits", name)
			end
		else
			worm:damage(amount,object:player())
			stats.add(object, "hits", name)
		end
	end
	
--PROJECTILES DAMAGE
	function damage.lightning(object,worm)
		damage.main(object,worm,0.92,"Lightning Gun")
	end

	function damage.chaingun(object,worm)
		damage.main(object,worm,6.25,"Chaingun")
	end
	
	function damage.rifle(object,worm)
		damage.main(object,worm,49,"Rifle")
	end
	
	function damage.gauss(object,worm)
		if gameMode == 5 then
			damage.main(object,worm,100,"Gauss Gun ")
		else
			damage.main(object,worm,1,"Gauss Gun")
		end
	end
	
	function damage.winchester(object,worm)
		damage.main(object,worm,24.5,"Winchester")
	end
	
	function damage.flak(object,worm)
		damage.main(object,worm,9,"Flak Cannon")
	end
	
	function damage.bazooka(object,worm)
		damage.main(object,worm,39,"Bazooka")
	end
	
	function damage.shotgun(object,worm)
		damage.main(object,worm,7.5,"Shotgun")
	end

	function damage.grenade(object,worm)
		damage.main(object,worm,0,"Grenade")
	end

	function damage.grenade_launcher(object,worm)
		damage.main(object,worm,0,"Grenade Launcher")
	end	

	function damage.doomsday(object,worm)
		damage.main(object,worm,0,"Doomsday")
	end

	function damage.mortar(object,worm)
		damage.main(object,worm,0,"Mortar")
	end

--PARTICLES DAMAGE
	function damage.mortar_particle_close(object,worm)
		damage.main(object,worm,20,"null")
	end
	
	function damage.mortar_particle_medium(object,worm)
		damage.main(object,worm,15,"null")
	end
	
	function damage.mortar_particle_far(object,worm)
		damage.main(object,worm,10,"null")
	end
	
	function damage.launcher_particle_close(object,worm)
		damage.main(object,worm,25,"null")
	end
	
	function damage.launcher_particle_medium(object,worm)
		damage.main(object,worm,30,"null")
	end
	
--EXPLOSIONS DAMAGE
	function damage.explosion_2(object,worm)
		damage.main(object,worm,2,"null")
	end

	function damage.explosion_5(object,worm)
		damage.main(object,worm,5,"null")
	end
	
	function damage.explosion_6(object,worm)
		damage.main(object,worm,6,"null")
	end

	function damage.explosion_8(object,worm)
		damage.main(object,worm,8,"null")
	end

	function damage.explosion_10(object,worm)
		damage.main(object,worm,10,"null")
	end
	
	function damage.explosion_18(object,worm)
		damage.main(object,worm,18,"null")
	end
	
	function damage.explosion_20(object,worm)
		damage.main(object,worm,20,"null")
	end

	function damage.explosion_80(object,worm)
		damage.main(object,worm,80,"null")
	end
	
--SPECIAL EXPLOSIONS DAMAGE
	function damage.special_explosion_mortar(object,worm)
		local ox,oy = object:pos()
		local wx,wy = worm:pos()
		
	--DAMAGE SETUP
		local range = 45	--MAX RANGE
		local power = 120	--POWER IN FIRST STEP
		local steps = 5		--AMOUNT OF STEPS
		
		local tempsteps = steps
		
		if not (map_is_blocked(ox, oy, wx, wy)) then
			while tempsteps > 0 do
				if vector_distance(ox, oy, wx, wy) < (range / tempsteps) then
					damage.main(object,worm,floor(power/steps),"null")
				end
				tempsteps = tempsteps - 1
			end
		end
	end
	
	function damage.special_explosion_grnlauncher(object,worm)
		local ox,oy = object:pos()
		local wx,wy = worm:pos()
		
	--DAMAGE SETUP
		local range = 90	--MAX RANGE
		local power = 80	--POWER IN FIRST STEP
		local steps = 4	--AMOUNT OF STEPS
		
		local tempsteps = steps
		
		if not (map_is_blocked(ox, oy, wx, wy)) then
			while tempsteps > 0 do
				if vector_distance(ox, oy, wx, wy) < (range / tempsteps) then
					damage.main(object,worm,floor(power/steps),"null")
				end
				tempsteps = tempsteps - 1
			end
		end
	end
end
