function mode.init()

	local ballOwner = nil
	local balltype = load_particle("ballpark/poop.obj")
	local ballCount = 0

	modes = {}
		modes["ffa"] = 1
		modes["1v1"] = 2
		modes["tdm"] = 3
		modes["ctf"] = 4
		modes["instagib"] = 5
		modes["ballpark"] = 6
		
	modes_ = {}
		modes_[0] = "ffa"
		modes_[1] = "ffa"
		modes_[2] = "1v1"
		modes_[3] = "tdm"
		modes_[4] = "ctf"
		modes_[5] = "instagib"
		modes_[6] = "ballpark"
		

	console_register_command("PM_MODE",function(id, map)
		if id == nil then
			return "MODE IS: "..modes_[gameMode].." DEFAULT: ffa"
		elseif id ~= nil and map ~= nil then
			if AUTH or DEDSERV and id ~= "" and map ~= "" then
				if tostring(id) and tostring(map) then
					if string.lower(id) == "ffa" or string.lower(id) == "1v1" or string.lower(id) == "tdm" or string.lower(id) == "ctf" or string.lower(id) == "instagib" or string.lower(id) == "ballpark" then
						for m in maps() do
							if string.lower(map) == string.lower(m) then
								console.sv_team_play = modes[id]
								host(string.lower(map))
							end
						end
					else
						return "MODE IS: "..modes_[gameMode].." DEFAULT: ffa"
					end
				else
					return "MODE IS: "..modes_[gameMode].." DEFAULT: ffa"
				end
			else
				return "MODE IS: "..modes_[gameMode].." DEFAULT: ffa"
			end
		else
			return "MODE IS: "..modes_[gameMode].." DEFAULT: ffa"
		end
	end)
	
	function inGame()
		local count = 0
		
		for p in game_players() do
			if p:team() ~= 0 then
				count = count + 1
			end
		end
		return count
	end

	function mode.message(message, worm)
		draw.message(message, 1, 300, worm, -110, color(255, 127, 0), 1, true, 15)
	end
	
	local timerStart = network_player_event("kotb_timerStart", function(self, p, data)
		p:stats().kotb_timer = data:get_int()
		p:data().kotb_timerRunning = true
		ballOwner = p:worm()
	end)
	
	local timerStop = network_player_event("kotb_timerStop", function(self, p, data)
		p:stats().kotb_timer = data:get_int()
		p:data().kotb_timerRunning = false
		if ballOwner == p:worm() then
			ballOwner = nil
		end
	end)

	function mode.bpCreateStuff(x, y)
		if ballCount == 0 then
			balltype:put(x, y)
			ballCount = 1
		end
	end
	
	function mode.bpBallThink(object, worm)
		if ballOwner and gameMode == 6 then
				object:set_pos(ballOwner:pos())
		end
	end
	
	local function pickupBall(worm)
		if not AUTH then return end
		
		if not ballOwner then
			local p = worm:player()
			local b = new_bitstream()
			b:add_int(p:stats().kotb_timer)
			timerStart:send(p, b)
			ballOwner = worm
			p:data().kotb_timerRunning = true
		end
	end
	
	function mode.bpSetOwner(object, worm)
		if gameMode == 6 then
			pickupBall(worm)
		end
	end
	
	local function dropBall(worm)
		if not AUTH then return end
		
		if ballOwner == worm then
			local p = worm:player()
			if p then
				local b = new_bitstream()
				b:add_int(p:stats().kotb_timer)
				timerStop:send(p, b)
				p:data().kotb_timerRunning = false
			end
			ballOwner = nil
		end
	end
			
	function bindings.playerNetworkInit(p, connID)
		local d = p:data()
		local b = new_bitstream()
		b:add_int(p:stats().kotb_timer)
		if d.kotb_timerRunning then
			timerStart:send(p, b, connID)
		else
			timerStop:send(p, b, connID)
		end
	end
	
	function bindings.playerInit(p)
		local d = p:data()
		
		d.canJoin = false
		d.kotb_timerRunning = false
		p:stats().kotb_timer = 0
		if AUTH and gameMode == 6 and ballCount == 0 then
			repeat
				ballX = randomint(1, 1000)
				ballY = randomint(1, 1000)
			until map_is_particle_pass(ballX, ballY)
			mode.bpCreateStuff(ballX, ballY)
			debug("Ball pos: "..ballX..", "..ballY)
		end
	end
		
	function bindings.playerUpdate(p)
		local d = p:data()
		
		if p:worm():health() > 0 and p:team() == 0 then
			p:worm():damage(100)
		end
		
		if gameMode ~= 2 then
			d.canJoin = true
		else
			if inGame() < 2 then
				d.canJoin = true
			end
		end
		
		if p:team() ~= 0 and not d.canJoin then
			console.p0_team = 0
			console.p1_team = 0
		end
		
		if d.kotb_timerRunning and gameMode == 6 then
			p:stats().kotb_timer = p:stats().kotb_timer + 1
		end
	end
			
	function bindings.wormDeath(worm)
		if gameMode == 6 then
			dropBall(worm)
		end
	end
	
	function bindings.wormRemoved(worm)
		if gameMode == 6 then
			dropBall(worm)
		end
	end
	
	function bindings.localplayerEvent(player, event, state)
		if event == Player.Jump and state and player:team() == 0 and player:worm():health() <= 0 then
			return true
		end
	end
end
