function timelimit.init()

	local game_end_obj = load_particle("game_end_holder.obj")
	local once_flag = 1
	local game_end = 0
	game_end_time_number = 90000

	local gameEnded = network_player_event("gameEnded", function(self, player, game_end_data)
		game_end = 1
	end)	
	
	function timelimit.MaxTimes()
		local actualTimes = 0
		for p in game_players() do
			if p:stats().timer > actualTimes then
				actualTimes = p:stats().timer
			end
		end
		return actualTimes
	end
	
	local max_time_count = timelimit.MaxTimes()

	function bindings.playerUpdate(player)
		local worm = player:worm()
		max_time_count = timelimit.MaxTimes()

		if game_end > 0 then
			if once_flag == 1 then
				--game_end_message = " - - - GAME OVER - - - GAME OVER - - - GAME OVER - - - GAME OVER - - - GAME OVER - - - GAME OVER - - - GAME OVER - - - "
				game_end_obj:put(1,1)
				once_flag = 0
			else
				if worm:health()<100 then
					worm:damage(-(100-worm:health()))
				end
			end
		end

		if (max_time_count >= game_end_time_number) and game_end_time_number > 0 and game_end_time_number > 0 then
			if AUTH then
				game_end = 1
				gameEnded:send(player)
			end
		end
	end		
end